define([
    'jquery',
    'mage/utils/wrapper',
    'Magento_Checkout/js/model/quote'
], function ($, wrapper, quote) {
    'use strict';
    return function (setShippingInformationAction) {
        return wrapper.wrap(setShippingInformationAction, function (originalAction) {
            var shippingAddress = quote.shippingAddress();

            if ($("input[name='custom_attributes[is_subscribe_for_newsletter]']").length) {
                if (shippingAddress['extension_attributes'] === undefined) {
                    shippingAddress['extension_attributes'] = {};
                }
//                shippingAddress['extension_attributes']['is_subscribe_for_newsletter'] = shippingAddress.customAttributes['is_subscribe_for_newsletter'];
                shippingAddress['extension_attributes']['is_subscribe_for_newsletter'] = $("input[name='custom_attributes[is_subscribe_for_newsletter]']").is(":checked");
            }
            
            // pass functionality to original action ('Magento_Checkout/js/action/set-shipping-information')
            return originalAction();
        });
    };
});